import { system, world, Player, ItemStack } from "@minecraft/server";
import { ITEMS } from "./items"

const minTime = 10; // In seconds
const maxTime = 10; // In seconds
const minAmount = 1; // In Single Items
const maxAmount = 1; // In Single Items

system.runTimeout(() => {
    spawnerEvent();
}, 60);

function spawnerEvent() {
    system.runTimeout(() => {
        spawnerEvent();
    }, (20 * (Math.floor(Math.random() * (maxTime - minTime + 1)) + minTime)));
    world.getAllPlayers().forEach(player => {
        let item = ITEMS[Math.floor(Math.random() * ITEMS.length)];
        let itemStackTest = new ItemStack(item, 1);
        let itemStackSize = itemStackTest.maxAmount;

        let itemAmount = Math.floor(Math.random() * (maxAmount - minAmount + 1)) + minAmount;
        let stacks = Math.floor(itemAmount / itemStackSize);
        let remainder = itemAmount % itemStackSize;

        let itemStack = new ItemStack(item, itemStackSize);

        for (let i = 0; i < stacks; i++) {
            player?.dimension?.spawnItem(itemStack, player?.location);
        }
        if (remainder != 0) {
            player?.dimension?.spawnItem(new ItemStack(item, remainder), player?.location);
        } 
    });
}
